=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg1//,repacksuffix=+dfsg1,filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/mir-$1.tar.gz/ \
https://github.com/MirServer/mir/tags .*/archive/refs/tags/v?([\d\.]+).tar.gz
